//    Organic Photovoltaic Device Model - a drift diffusion base/Shockley-Read-Hall
//    model for organic solar cells. 
//    Copyright (C) 2012 Roderick C. I. MacKenzie
//
//	roderick.mackenzie@nottingham.ac.uk
//	www.roderickmackenzie.eu
//	Room B86 Coates, University Park, Nottingham, NG7 2RD, UK
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License along
//    with this program; if not, write to the Free Software Foundation, Inc.,
//    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

#ifndef sim_modes_h
#define sim_modes_h
#define sim_mode_jv	0
#define sim_mode_tpv	1
#define sim_mode_ce	2
#define sim_mode_li_sc	3
#define sim_mode_tpc	4
#define sim_mode_li	5
#define sim_mode_sun_voc 7
#define sim_mode_jvone 	8
#define sim_mode_tof 	11
#define sim_mode_fft 	12
#define sim_mode_celiv 	14
#define sim_mode_otrace 	15
#define sim_mode_stark	17
#define sim_mode_findlight_for_voc 18
#define sim_mode_qe 21
#define sim_mode_pulse 	22
#define sim_mode_shg	24
#define sim_mode_imps 25
#define sim_mode_pulse_voc	27
#define sim_mode_jv_simple	28
#define sim_mode_optics		33
#define sim_mode_stark_spectrum 34
#endif
